import * as React from "react";
import {
    ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
    ColumnSeries,
    SplineSeries,
    DateTime,
    Tooltip,
    LineSeries,
    BarSeries
} from '@syncfusion/ej2-react-charts';

import { IChartComponentProps, IBasicChartProps } from "../../Defs/ChartDefs";

//SAMPLE DATASOURCE FOR YOUR REFERENCE 
// const datasource = [
//     {
//         xName: 'x',
//         yName: 'y',
//         source: [
//             { x: 1900, y: 4, y1: 2.6, y2: 2.8 }, { x: 1920, y: 3.0, y1: 2.8, y2: 2.5 },
//             { x: 1940, y: 3.8, y1: 2.6, y2: 2.8 }, { x: 1960, y: 3.4, y1: 3, y2: 3.2 },
//             { x: 1980, y: 3.2, y1: 3.6, y2: 2.9 }, { x: 2000, y: 3.9, y1: 3, y2: 2 }
//         ],
//         dashArray: "5,1"

//     },
//     {
//         xName: 'x',
//         yName: 'y',
//         source: [
//             { x: 1901, y: 5, y1: 3.6, y2: 2.8 }, { x: 1920, y: 3.0, y1: 2.8, y2: 2.5 },
//             { x: 1940, y: 3.8, y1: 2.6, y2: 2.8 }, { x: 1961, y: 4.4, y1: 3, y2: 3.1 },
//             { x: 1981, y: 3.2, y1: 3.6, y2: 3.9 }, { x: 2000, y: 3.9, y1: 4, y2: 2 }
//         ]

//     }
// ]


class BasicChart extends React.Component<IChartComponentProps, {}> {
    private ChartRef: ChartComponent
    render() {
        const props: IBasicChartProps = this.props.json;
        return (

            this.props.json ?
                <ChartComponent
                    ref={(instance) => this.ChartRef = instance}
                    style={{
                        height: 'inherit',
                        ...props.style
                    }}
                    {...props.chart}
                    width="100%"
                >
                    <Inject services={[BarSeries, ColumnSeries, LineSeries, SplineSeries, DateTime, Tooltip]} />
                    {
                        props.datasource ?
                            <SeriesCollectionDirective>
                                {
                                    props.datasource.map((data, i) =>
                                        <SeriesDirective
                                            key={i}
                                            dataSource={data.source}
                                            xName={data.xName}
                                            yName={data.yName}
                                            type={props.type}
                                            dashArray={data.dashArray}
                                            {...props.series} />
                                    )
                                }
                            </SeriesCollectionDirective>
                            : null
                    }
                </ChartComponent>
                : null
        )
    }
    componentDidUpdate() {
        console.log("componentDidUpdate");
        this.ChartRef.refresh()
        //chart.redraw();
    }
    componentDidCatch(error: any, info: any) {
        console.log(error);
    }
}
export default BasicChart;