import { ChartSeriesType, LegendShape, SparklineModel } from "@syncfusion/ej2-charts";

import { AxisModel, AnnotationModel, RangeModel, PointerModel, CircularGaugeModel } from "@syncfusion/ej2-circulargauge";

import { ChartModel, SeriesModel } from "@syncfusion/ej2-charts/src/chart";

import { DataManager } from "@syncfusion/ej2-data";

export interface IChartComponentProps {
    json: any
}

export interface IBasicChartProps {
    datasource: chartSource[]
    type: ChartSeriesType

    chart?: ChartModel
    style?: React.CSSProperties

    series?: SeriesModel

    legendShape?: LegendShape
    width?: number
}

export interface ISparkilineProps {
    props: SparklineModel
    style?: React.CSSProperties
}

export interface ICirculaGaugeProps {
    value: number
    id: string

    AxisDirective?: AxisModel
    RangeDirective?: RangeModel
    AnnotationDirective?: AnnotationModel
    PointerDirective?: PointerModel

    Gauge?: CircularGaugeModel
}

interface chartSource {
    source: Object | DataManager
    xName?: string
    yName?: string
    dashArray?: string
}
